Subject: bug#39484: 26.3; try-completion bug

From: Stefan Monnier <[email-masked]>
Date: Wed, 28 Oct 2020 10:45:07 -0400

> 1. Return value is not ideal. You can argue it is still not wrong, but
>    I think we can improve.

Indeed, it can be improved, but we should not try to be too clever about
it, because some choices might seem obvious in some circumstances but
would result in rather poor answers in other cases.

So rather than hypothetical cases like what we've seen here, I'm much
more interested in real life situations.

The current design is trying to be conservative, in the sense that it
tries to avoid returning a poor result, at the cost of sometimes failing
to return a better result.  It does it by refraining from mix-and-match:
either the whole result comes from the user input or the whole result
comes from *one* of the candidates.

There are cases where `completion-try-completion` (as opposed to
`try-completion`) doesn't actually follow this rule correctly, and it's
been a source of suboptimal results.

        Stefan